Skip to main content

Overview

MessageComposer is a Component that enables users to write and send a variety of messages, including text, image, video, and custom messages. Features such as Live Reaction, Attachments, and Message Editing are also supported by it.
MessageComposer is comprised of the following Base Components:
Base ComponentsDescription
MessageInputThis provides a basic layout for the contents of this component, such as the TextField and buttons
ActionSheetThe ActionSheet component presents a list of options in either a list or grid mode, depending on the user’s preference

Usage

Integration

The following code snippet illustrates how you can directly incorporate the MessageComposer component into your app.
import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { CometChatMessageComposer } from '@cometchat/chat-uikit-angular';
import { AppComponent } from './app.component';

@NgModule({
  imports: [
    BrowserModule,
    CometChatMessageComposer
  ],
  declarations: [AppComponent],
  providers: [],
  bootstrap: [AppComponent],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class AppModule { }

Actions

Actions dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.
1. OnSendButtonClick
The OnSendButtonClick event gets activated when the send message button is clicked. It has a predefined function of sending messages entered in the composer EditText. However, you can overide this action with the following code snippet.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  public handleOnSendButtonClick = (message: CometChat.BaseMessage) =>{
    console.log("Your Custom send button click actions", message);
  };

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}
2. onError
This action doesn’t change the behavior of the component but rather listens for any errors that occur in the MessageList component.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  public handleOnError = (error: CometChat.CometChatException) => {
    console.log("your custom on error action", error);
  };

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

Filters

MessageComposer component does not have any available filters.

Events

Events are emitted by a Component. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed. The list of events emitted by the Messages component is as follows.
EventDescription
ccMessageEditedTriggers whenever a loggedIn user edits any message from the list of messages .it will have three states such as: inProgress, success and error
ccMessageSentTriggers whenever a loggedIn user sends any message, it will have three states such as: inProgress, success and error
ccLiveReactionTriggers whenever a loggedIn clicks on live reaction
Adding CometChatMessageEvents Listener’s
import {CometChatMessageEvents} from "@cometchat/chat-uikit-angular";

this.ccMessageEdited = CometChatMessageEvents.ccMessageEdited.subscribe(
 () => {
        // Your Code
  }   
);

this.ccMessageSent = CometChatMessageEvents.ccMessageSent.subscribe(
  () => {
        // Your Code
  }        
);

this.ccLiveReaction = CometChatMessageEvents.ccLiveReaction.subscribe(
  () => {
        // Your Code
  }      
);

Removing CometChatMessageEvents Listener’s
this.ccMessageEdited.unsubscribe();
this.ccMessageSent.unsubscribe();

Customization

To fit your app’s design requirements, you can customize the appearance of the MessageComposer component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.
1. MessageComposer Style
To modify the styling, you can apply the MessageComposerStyle to the MessageComposer Component using the messageComposerStyle property.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import { MessageComposerStyle } from '@cometchat/uikit-shared';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  messageComposerStyle = new MessageComposerStyle({
    AIIconTint:"#ec03fc",
    attachIcontint:"#ec03fc",
    background:"#fffcff",
    border:"2px solid #b30fff",
    borderRadius:"20px",
    inputBackground:"#e2d5e8",
    textColor:"#ff299b",
    sendIconTint:"#ff0088",  
  });
  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}
The following properties are exposed by MessageComposerStyle:
PropertyDescriptionCode
borderUsed to set borderborder?: string,
borderRadiusUsed to set border radiusborderRadius?: string;
backgroundUsed to set background colourbackground?: string;
heightUsed to set heightheight?: string;
widthUsed to set widthwidth?: string;
inputBackgroundUsed to set input background colorinputBackground?: string;
inputBorderused to set input borderinputBorder?: string;
inputBorderRadiusused to set input border radiusinputBorderRadius?: string;
textFontUsed to set input text fonttextFont?: string;
textColorused to set input text colortextColor?: string;
placeHolderTextColorUsed to set placeholder text colorplaceHolderTextColor?: string;
placeHolderTextFontUsed to set placeholder text fontplaceHolderTextFont?: string;
attachIcontintUsed to set attachment icon tintattachIcontint?: string;
sendIconTintUsed to set send button icon tintsendIconTint?: string;
dividerTintUsed to set separator colordividerTint?: string;
voiceRecordingIconTintused to set voice recording icon colorvoiceRecordingIconTint?: string;
emojiIconTintused to set emoji icon coloremojiIconTint?: string;
AIIconTintused to set AI icon colorAIIconTint?: string;
emojiKeyboardTextFontused to set emoji keyboard text fontemojiKeyboardTextFont?: string;
previewTitleFontused to set preview title fontpreviewTitleFont?: string;
previewTitleColorused to set preview title colorpreviewTitleColor?: string;
previewSubtitleFontused to set preview subtitle fontpreviewSubtitleFont?: string;
previewSubtitleColorused to set preview subtitle colorpreviewSubtitleColor?: string;
closePreviewTintused to set close preview colorclosePreviewTint?: string;
maxInputHeightused to set max input heightmaxInputHeight?: string;
2. MediaRecorder Style
To customize the styles of the MediaRecorder component within the MessageComposer Component, use the mediaRecorderStyle property. For more details, please refer to MediaRecorder styles.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import {  CometChatThemeService, CometChatUIKit, MediaRecorderStyle } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  mediaRecorderStyle = new MediaRecorderStyle({
    background:"#f2f5fa",
    border:"2px solid #be0be6",
    closeIconTint:"#830be6",
    submitIconTint:"#c2a3ff",
    startIconTint:"#a313f0"
  });
  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}
3. MentionsWarning Style
To customize the styles of the MentionsWarning within the MessageComposer Component, use the mentionsWarningStyle property.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  mentionsWarningStyle: any = ({
    backgroundColor:'red',
    height:'50px',
    width:'200px'
  });
  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}
Below is a list of customizations along with corresponding code snippets
PropertyDescriptionCode
User Used to pass user object of which header specific details will be show[user]="userObject"
Group Used to pass group object of which header specific details will be shown[group]="groupObject"
placeHolderTextUsed to set composer’s placeholder textplaceHolderText="your custom placeholder text"
mentionsWarningTextText to be displayed when max limit reaches for valid mentions[mentionsWarningText]="'Your Custom Mentions warning Text'"
disableTypingEventsUsed to disable/enable typing events , default false[disableTypingEvents]="true"
disableSoundForMessagesUsed to toggle sound for outgoing messages[disableSoundForMessages]="true"
sendButtonIconURLUsed to set send button iconsendButtonIconURL="your custom isend button icon url"
textUsed to set predefined texttext="Your custom text"
voiceRecordingStartIconURLSets custom icon for voice recording start.voiceRecordingStartIconURL="your custom voice recording start icon"
voiceRecordingStopIconURLSets custom icon for voice recording stop.voiceRecordingStopIconURL="your custom voice recording stop icon"
voiceRecordingCloseIconURLSets custom icon for voice recording close.voiceRecordingCloseIconURL="your custom voice recording close icon"
voiceRecordingSubmitIconURLSets custom icon for voice recording submitvoiceRecordingSubmitIconURL="your custom voice recording submit icon"
auxiliaryButtonAlignmentcontrols position of auxiliary button view , can be left or right . default rightauxiliaryButtonAlignment=AuxiliaryButtonAlignment.left
attachmentIconURLsets the icon to show in the attachment buttonattachmentIconURL="your custom attachment icon url"
hideLiveReactionused to toggle visibility for live reaction component[hideLiveReaction]="true"
customSoundForMessageUsed to give custom sounds to outgoing messagescustomSoundForMessage="your custom sound for messages"
LiveReactionIconURLused to set custom live reaction icon.LiveReactionIconURL="your custom live reaction icon"
AIIconURLused to set custom AI icon.AIIconURL="your custom AI icon"
emojiIconURLused to set custom emoji icon.emojiIconURL="your custom emoji icon"
hideLayoutModeused to hide the layout mode.[hideLayoutMode]="true"
hideVoiceRecordingused to hide the voice recording option.[hideVoiceRecording]="true"
Disable MentionsSets whether mentions in text should be disabled. Processes the text formatters If there are text formatters available and the disableMentions flag is set to true, it removes any formatters that are instances of CometChatMentionsFormatter.[disableMentions]="true"

Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

AttachmentOptions

By using attachmentOptions, you can set a list of custom MessageComposerActions for the MessageComposer Component. This will override the existing list of MessageComposerActions. Example
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit, ComposerId } from '@cometchat/chat-uikit-angular';
import { CometChatMessageComposerAction } from '@cometchat/uikit-resources';

import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }
  getAttachmentOptions = (item: CometChat.User | CometChat.Group, composerId: ComposerId)=>{
    const CustomAttachment = [
      new CometChatMessageComposerAction({
          id: 'your custom id',
          iconURL: 'icon',
          background: 'blue',
          title: 'Your Custom Title',
          iconTint: '#9000ff'
      })
    ];
    if(item instanceof CometChat.User) {
      //push user specific custom attachment options
    } else if(item instanceof CometChat.Group) {
      //push group specific custom attachment options
    }
    return CustomAttachment;
  };

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

AuxiliaryButtonView

You can insert a custom view into the MessageComposer component to add additional functionality using the following method. Please note that the MessageComposer Component utilizes the AuxiliaryButton to provide sticker functionality. Overriding the AuxiliaryButton will subsequently replace the sticker functionality. In this example, we’ll be adding a custom SOS button. Example
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit, IconStyle } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  name = 'Your Custom name';
  auxiliaryButtonURL = 'Your custom url';
  getIconStyle = new IconStyle({
    iconTint:"#d400ff",
  });

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

SecondaryButtonView

You can add a custom view into the SecondaryButton component for additional functionality using the below method. In this example, we’ll be adding a custom SOS button. Example
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit, IconStyle } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  name = 'Your Custom name';
  secondaryButtonURL = 'Your custom url';
  getIconStyle = new IconStyle({
    iconTint:"#d400ff",
  });

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

SendButtonView

You can set a custom view in place of the already existing send button view. Using the following method. Example
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit, IconStyle } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }

  name = 'Your Custom name';
  customURL = 'Your custom url';
  getIconStyle = new IconStyle({
    iconTint:"#d400ff",
  });

  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

HeaderView

You can set custom headerView to the MessageComposer component using the following method In the following example, we’re going to apply a mock chat bot button to the MessageComposer Component using the headerView property. Example
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }
  myCustomIcon = 'Your custom url';


  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}

TextFormatters

Assigns the list of text formatters. If the provided list is not null, it sets the list. Otherwise, it assigns the default text formatters retrieved from the data source. To configure the existing Mentions look and feel check out CometChatMentionsFormatter. Example
import { CometChatTextFormatter } from "@cometchat/uikit-shared";
import { Subject } from 'rxjs';
import { CometChat } from "@cometchat/chat-sdk-javascript";

export class ShortcutFormatter extends CometChatTextFormatter {
    private shortcuts: { [key: string]: string } = {};
    private dialogIsOpen: boolean = false;
    private currentShortcut: string | null = null;
    private openDialogSubject = new Subject<{ closeDialog?: boolean, buttonText?: string, shortcut?: string, handleButtonClick?:any }>();
    openDialog$ = this.openDialogSubject.asObservable();

    constructor() {
        super();
        this.setTrackingCharacter('!');
        CometChat.callExtension('message-shortcuts', 'GET', 'v1/fetch', undefined)
            .then((data: any) => {
                if (data && data.shortcuts) {
                    this.shortcuts = data.shortcuts;
                }
            })
            .catch(error => console.log("error fetching shortcuts", error));
    }

    override onKeyDown(event: KeyboardEvent) {
        const caretPosition = this.currentCaretPosition instanceof Selection
            ? this.currentCaretPosition.anchorOffset
            : 0;
        const textBeforeCaret = this.getTextBeforeCaret(caretPosition);

        const match = textBeforeCaret.match(/!([a-zA-Z]+)$/);
        if (match) {
            const shortcut = match[0];
            const replacement = this.shortcuts[shortcut];
            if (replacement) {
                if (this.dialogIsOpen && this.currentShortcut !== shortcut) {
                    this.closeDialog();
                }
                this.openDialog(replacement, shortcut);
            }
        }
    }

    getCaretPosition() {
        if (!this.currentCaretPosition?.rangeCount) return { x: 0, y: 0 };
        const range = this.currentCaretPosition?.getRangeAt(0);
        const rect = range.getBoundingClientRect();
        return {
            x: rect.left,
            y: rect.top
        };
    }

    openDialog(buttonText: string, shortcut: string) {
        this.openDialogSubject.next({ buttonText, shortcut , handleButtonClick: this.handleButtonClick});
        this.dialogIsOpen = true;
        this.currentShortcut = shortcut;
    }

    closeDialog() {
        this.openDialogSubject.next({closeDialog: true});
    }

    handleButtonClick = (buttonText: string) => {
        console.log(buttonText);
        
        if (this.currentCaretPosition && this.currentRange) {
            const shortcut = Object.keys(this.shortcuts).find(key => this.shortcuts[key] === buttonText);
            if (shortcut) {
                const replacement = this.shortcuts[shortcut];
                this.addAtCaretPosition(replacement, this.currentCaretPosition, this.currentRange);
            }
        }
        if (this.dialogIsOpen) {
            this.closeDialog();
        }
    };

    override getFormattedText(text: string): string {
        return text;
    }

    private getTextBeforeCaret(caretPosition: number): string {
        if (this.currentRange && this.currentRange.startContainer && typeof this.currentRange.startContainer.textContent === "string") {
            const textContent = this.currentRange.startContainer.textContent;
            if (textContent.length >= caretPosition) {
                return textContent.substring(0, caretPosition);
            }
        }
        return "";
    }
}

export default ShortcutFormatter;

Configuration

Configurations offer the ability to customize the properties of each component within a Composite Component.

UserMemberWrapper

From the MessageComposer, you can navigate to the UserMemberWrapper component as shown in the image.
If you wish to modify the properties of the UserMemberWrapper Component, you can use the UserMemberWrapperConfiguration object.
import { CometChat } from '@cometchat/chat-sdk-javascript';
import { Component, OnInit } from '@angular/core';
import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
import { UserMemberWrapperConfiguration } from '@cometchat/uikit-shared';
import { UserPresencePlacement } from '@cometchat/uikit-resources';
import "@cometchat/uikit-elements";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit{

  ngOnInit(): void {
    CometChat.getUser("uid").then((user:CometChat.User)=>{
      this.userObject=user;
    });
  }

  public userObject!: CometChat.User;

  constructor(private themeService:CometChatThemeService) {
    themeService.theme.palette.setMode("light")
    themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
  }
  public userMemberWrapperConfiguration= new UserMemberWrapperConfiguration({
    userPresencePlacement: UserPresencePlacement.right,
    //properties of UserMemberWrapper
  });


  onLogin(UID?: any) {
    CometChatUIKit.login({ uid: UID }).then(
      (user) => {
        setTimeout(() => {
          window.location.reload();
        }, 1000);
      },
      (error) => {
        console.log("Login failed with exception:", { error });
      }
    );
  }
}
The UserMemberWrapperConfiguration indeed provides access to all the Action, Filters, Styles, Functionality, and Advanced properties of the UserMemberWrapper component. Please note that the Properties marked with the 🛑 symbol are not accessible within the Configuration Object. Example
In the above example, we are styling a few properties of the UserMemberWrapper component using UserMemberWrapperConfiguration.

Skip to main content

Overview

MessageComposer is a Component that enables users to write and send a variety of messages, including text, image, video, and custom messages. Features such as Attachments, and Message Editing are also supported by it.

Usage

Integration

The following code snippet illustrates how you can directly incorporate the MessageComposer component into your app.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

export function MessageComposerDemo() {
  const [chatUser, setChatUser] = React.useState<CometChat.User>();
  React.useEffect(() => {
    CometChat.getUser("uid").then((user) => {
      setChatUser(user);
    });
  }, []);

  return chatUser ? (
    <div>
      <CometChatMessageComposer user={chatUser} />
    </div>
  ) : null;
}

Actions

Actions dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.
1. OnSendButtonClick
The OnSendButtonClick event gets activated when the send message button is clicked. It has a predefined function of sending messages entered in the composer EditText. However, you can overide this action with the following code snippet.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

export function MessageComposerDemo() {
  const [chatUser, setChatUser] = React.useState<CometChat.User>();

  React.useEffect(() => {
    CometChat.getUser("uid").then((user) => {
      setChatUser(user);
    });
  }, []);

  function handleSendButtonClick(message: CometChat.BaseMessage): void {
    console.log("your custom on send buttonclick action");
  }

  return chatUser ? (
    <div>
      <CometChatMessageComposer onSendButtonClick={handleSendButtonClick} />
    </div>
  ) : null;
}
2. onError
This action doesn’t change the behavior of the component but rather listens for any errors that occur in the MessageList component.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

export function MessageComposerDemo() {
  const [chatUser, setChatUser] = React.useState<CometChat.User>();

  React.useEffect(() => {
    CometChat.getUser("uid").then((user) => {
      setChatUser(user);
    });
  }, []);

  function handleError(error: CometChat.CometChatException) {
    throw new Error("your custom error action");
  }

  return chatUser ? (
    <div>
      <CometChatMessageComposer user={chatUser} onError={handleError} />
    </div>
  ) : null;
}
3. onTextChange
This event is triggered as the user starts typing in the Message Composer.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

export function MessageComposerDemo() {
  const [chatUser, setChatUser] = React.useState<CometChat.User>();

  React.useEffect(() => {
    CometChat.getUser("uid").then((user) => {
      setChatUser(user);
    });
  }, []);

  function handleTextChange(text: string) {
    console.log("onTextChange", text);
  }

  return chatUser ? (
    <div>
      <CometChatMessageComposer
        user={chatUser}
        onTextChange={handleTextChange}
      />
    </div>
  ) : null;
}
4. Custom Mentions Request Builders
You can customize how mentioned users and group members are fetched by providing custom request builders.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

export function MessageComposerDemo() {
  const [chatUser, setChatUser] = React.useState<CometChat.User>();
  const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

  React.useEffect(() => {
    CometChat.getUser("uid").then((user) => {
      setChatUser(user);
    });
    CometChat.getGroup("guid").then((group) => {
      setChatGroup(group);
    });
  }, []);

  // Custom Users Request Builder for mentions
  const mentionsUsersRequestBuilder = new CometChat.UsersRequestBuilder()
    .setLimit(10)
    .setSearchKeyword("")
    .setRoles(["default", "moderator"]);

  // Custom Group Members Request Builder for group mentions
  const mentionsGroupMembersRequestBuilder = new CometChat.GroupMembersRequestBuilder("guid")
    .setLimit(15)
    .setSearchKeyword("")
    .setScopes(["admin", "moderator", "participant"]);

  return chatUser ? (
    <div>
      {/* For user chat with custom users mentions */}
      <CometChatMessageComposer
        user={chatUser}
        mentionsUsersRequestBuilder={mentionsUsersRequestBuilder}
      />
      
      {/* For group chat with custom group members mentions */}
      {chatGroup && (
        <CometChatMessageComposer
          group={chatGroup}
          mentionsGroupMembersRequestBuilder={mentionsGroupMembersRequestBuilder}
        />
      )}
    </div>
  ) : null;
}

Filters

MessageComposer component does not have any available filters.

Events

Events are emitted by a Component. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed. The list of events emitted by the Messages component is as follows.
EventDescription
ccMessageEditedTriggers whenever a loggedIn user edits any message from the list of messages .it will have three states such as: inProgress, success and error.
ccReplyToMessageTriggers whenever a loggedIn user replies to any message from the list of messages .it will have three states such as: inProgress, success and error.
ccMessageSentTriggers whenever a loggedIn user sends any message, it will have three states such as: inProgress, success and error.
Adding CometChatMessageEvents Listener’s
import { CometChatMessageEvents } from "@cometchat/chat-uikit-react";

const ccMessageEdited = CometChatMessageEvents.ccMessageEdited.subscribe(() => {
  // Your Code
});

const ccReplyToMessage = CometChatMessageEvents.ccReplyToMessage.subscribe(() => {
  // Your Code
});

const ccMessageSent = CometChatMessageEvents.ccMessageSent.subscribe(() => {
  // Your Code
});

Removing CometChatMessageEvents Listener’s
ccMessageEdited?.unsubscribe();
ccReplyToMessage?.unsubscribe();
ccMessageSent?.unsubscribe();

Customization

To fit your app’s design requirements, you can customize the appearance of the MessageComposer component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

Style

To modify the styling, you can customise the css of MessageComposer Component. Example
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

<CometChatMessageComposer user={chatUser} />;

Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

<CometChatMessageComposer user={chatUser} disableTypingEvents={true} />;
Below is a list of customizations along with corresponding code snippets
PropertyDescriptionCode
Initial Composer TextThe initial text pre-filled in the message input when the component mounts.initialComposerText="Hello"
Disable Typing EventsDisables the typing indicator for the current message composer.disableTypingEvents={true}
Disable MentionsDisables the mentions functionality in the message composer.disableMentions={true}
Disable Mention AllControls whether group mentions like @all appear in suggestions.disableMentionAll={true}
Mention All LabelAllows setting a custom alias label for group mentions (@channel, @everyone, etc.).mentionAllLabel="all"
Mentions Users Request BuilderProvides a custom UsersRequestBuilder to control how the mentioned users list is fetched.mentionsUsersRequestBuilder={usersRequestBuilder}
Mentions Group Members Request BuilderProvides a custom GroupMembersRequestBuilder to customize how mentioned group members are retrieved.mentionsGroupMembersRequestBuilder={groupMembersRequestBuilder}
Hide Image Attachment OptionHides the image attachment option in the message composer.hideImageAttachmentOption={true}
Hide Video Attachment OptionHides the video attachment option in the message composer.hideVideoAttachmentOption={true}
Hide Audio Attachment OptionHides the audio attachment option in the message composer.hideAudioAttachmentOption={true}
Hide File Attachment OptionHides the file attachment option in the message composer.hideFileAttachmentOption={true}
Hide Polls OptionHides the polls option in the message composer.hidePollsOption={true}
Hide Collaborative DocumentHides the collaborative document option in the message composer.hideCollaborativeDocumentOption={true}
Hide Collaborative WhiteboardHides the collaborative whiteboard option in the message composer.hideCollaborativeWhiteboardOption={true}
Hide Attachment ButtonHides the attachment button in the message composer.hideAttachmentButton={true}
Hide Voice Recording ButtonHides the voice recording button in the message composer.hideVoiceRecordingButton={true}
Hide Emoji Keyboard ButtonHides the emoji keyboard button in the message composer.hideEmojiKeyboardButton={true}
Hide Stickers ButtonHides the stickers button in the message composer.hideStickersButton={true}
Hide Send ButtonHides the send button in the message composer.hideSendButton={true}
Show ScrollbarControls the visibility of the scrollbar in the composer.showScrollbar={true}
UserSpecifies the recipient of the message (user object).user={chatUser}
GroupSpecifies the group to send messages to. Used if the user prop is not provided.group={chatGroup}
Parent Message IDSpecifies the ID of the parent message for threading or replying to a specific message.parentMessageId={12345}
Enter Key BehaviorDetermines the behavior of the Enter key (e.g., send message or add a new line).enterKeyBehavior={EnterKeyBehavior.SendMessage}
Disable Sound for MessageDisables sound for incoming messages.disableSoundForMessage={true}
Custom Sound for MessageSpecifies a custom audio sound for incoming messages.customSoundForMessage="sound.mp3"

Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

AttachmentOptions

By using attachmentOptions, you can set a list of custom MessageComposerActions for the MessageComposer Component. This will override the existing list of MessageComposerActions. Shown below is the default chat interface.
The customized chat interface is displayed below.
Use the following code to achieve the customization shown above.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import {
  CometChatMessageComposer,
  CometChatMessageComposerAction,
} from "@cometchat/chat-uikit-react";

function getAttachments() {
  return [
    new CometChatMessageComposerAction({
      id: "custom1",
      title: "Custom Option 1",
      iconURL: "Icon URL",
    }),
    new CometChatMessageComposerAction({
      id: "custom2",
      title: "Custom Option 2",
      iconURL: "Icon URL",
    }),
    new CometChatMessageComposerAction({
      id: "custom3",
      title: "Custom Option 3",
      iconURL: "Icon URL",
    }),
    new CometChatMessageComposerAction({
      id: "custom4",
      title: "Custom Option 4",
      iconURL: "Icon URL",
    }),
  ];
}

<CometChatMessageComposer
  attachmentOptions={getAttachments()}
  user={userObj}
/>;

AuxiliaryButtonView

You can insert a custom view into the MessageComposer component to add additional functionality using the following method. Please note that the MessageComposer Component utilizes the AuxiliaryButton to provide sticker and AI functionality. Overriding the AuxiliaryButton will subsequently replace the sticker functionality. Shown below is the default chat interface.
The customized chat interface is displayed below.
Use the following code to achieve the customization shown above.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import {
  CometChatMessageComposer,
  IconStyle,
  CometChatButton,
} from "@cometchat/chat-uikit-react";

const auxiliaryButtonView = (
  <CometChatButton
    iconURL="Icon URL"
    onClick={() => {
      // logic here
    }}
  />
);

<CometChatMessageComposer
  auxiliaryButtonView={auxiliaryButtonView}
  user={userObj}
/>;

SendButtonView

You can set a custom view in place of the already existing send button view. Shown below is the default chat interface.
The customized chat interface is displayed below.
Use the following code to achieve the customization shown above.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import {
  CometChatMessageComposer,
  CometChatButton,
} from "@cometchat/chat-uikit-react";

const sendButtonView = (
  <CometChatButton
    iconURL="Icon URL"
    onClick={() => {
      // logic here
    }}
  />
);

<CometChatMessageComposer sendButtonView={sendButtonView} user={userObj} />;

HeaderView

You can set custom headerView to the MessageComposer component using the following method. Shown below is the default chat interface.
The customized chat interface is displayed below.
Use the following code to achieve the customization shown above.
import React from "react";
import { CometChat } from "@cometchat/chat-sdk-javascript";
import { CometChatMessageComposer } from "@cometchat/chat-uikit-react";

const getHeaderView = () => {
  return (
    <div className="message-composer__header-view">
      <div className="message-composer__header-view-icon"></div>
      <div className="message-composer__header-view-text">
        User has paused their notifications
      </div>
    </div>
  );
};

<CometChatMessageComposer user={chatUser} headerView={getHeaderView()} />;

TextFormatters

Assigns the list of text formatters. If the provided list is not null, it sets the list. Otherwise, it assigns the default text formatters retrieved from the data source. To configure the existing Mentions look and feel check out CometChatMentionsFormatter
import { CometChatTextFormatter } from "@cometchat/chat-uikit-react";
import DialogHelper from "./Dialog";
import { CometChat } from "@cometchat/chat-sdk-javascript";

class ShortcutFormatter extends CometChatTextFormatter {
  private shortcuts: { [key: string]: string } = {};
  private dialogIsOpen: boolean = false;
  private dialogHelper = new DialogHelper();
  private currentShortcut: string | null = null; // Track the currently open shortcut

  constructor() {
    super();
    this.setTrackingCharacter("!");
    CometChat.callExtension("message-shortcuts", "GET", "v1/fetch", undefined)
      .then((data: any) => {
        if (data && data.shortcuts) {
          this.shortcuts = data.shortcuts;
        }
      })
      .catch((error) => console.log("error fetching shortcuts", error));
  }

  onKeyDown(event: KeyboardEvent) {
    const caretPosition =
      this.currentCaretPosition instanceof Selection
        ? this.currentCaretPosition.anchorOffset
        : 0;
    const textBeforeCaret = this.getTextBeforeCaret(caretPosition);

    const match = textBeforeCaret.match(/!([a-zA-Z]+)$/);
    if (match) {
      const shortcut = match[0];
      const replacement = this.shortcuts[shortcut];
      if (replacement) {
        // Close the currently open dialog, if any
        if (this.dialogIsOpen && this.currentShortcut !== shortcut) {
          this.closeDialog();
        }
        this.openDialog(replacement, shortcut);
      }
    }
  }

  getCaretPosition() {
    if (!this.currentCaretPosition?.rangeCount) return { x: 0, y: 0 };
    const range = this.currentCaretPosition?.getRangeAt(0);
    const rect = range.getBoundingClientRect();
    return {
      x: rect.left,
      y: rect.top,
    };
  }

  openDialog(buttonText: string, shortcut: string) {
    this.dialogHelper.createDialog(
      () => this.handleButtonClick(buttonText),
      buttonText
    );
    this.dialogIsOpen = true;
    this.currentShortcut = shortcut;
  }

  closeDialog() {
    this.dialogHelper.closeDialog(); // Use DialogHelper to close the dialog
    this.dialogIsOpen = false;
    this.currentShortcut = null;
  }

  handleButtonClick = (buttonText: string) => {
    if (this.currentCaretPosition && this.currentRange) {
      // Inserting the replacement text corresponding to the shortcut
      const shortcut = Object.keys(this.shortcuts).find(
        (key) => this.shortcuts[key] === buttonText
      );
      if (shortcut) {
        const replacement = this.shortcuts[shortcut];
        this.addAtCaretPosition(
          replacement,
          this.currentCaretPosition,
          this.currentRange
        );
      }
    }
    if (this.dialogIsOpen) {
      this.closeDialog();
    }
  };

  getFormattedText(text: string): string {
    return text;
  }

  private getTextBeforeCaret(caretPosition: number): string {
    if (
      this.currentRange &&
      this.currentRange.startContainer &&
      typeof this.currentRange.startContainer.textContent === "string"
    ) {
      const textContent = this.currentRange.startContainer.textContent;
      if (textContent.length >= caretPosition) {
        return textContent.substring(0, caretPosition);
      }
    }
    return "";
  }
}

export default ShortcutFormatter;